
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ContactsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const contacts = await db.contacts.create(
            {
                id: data.id || undefined,
        
        contact_type: data.contact_type
        ||
        null
            ,
            
        display_name: data.display_name
        ||
        null
            ,
            
        company_name: data.company_name
        ||
        null
            ,
            
        first_name: data.first_name
        ||
        null
            ,
            
        last_name: data.last_name
        ||
        null
            ,
            
        email: data.email
        ||
        null
            ,
            
        phone: data.phone
        ||
        null
            ,
            
        tin: data.tin
        ||
        null
            ,
            
        vrn: data.vrn
        ||
        null
            ,
            
        billing_address_line1: data.billing_address_line1
        ||
        null
            ,
            
        billing_address_line2: data.billing_address_line2
        ||
        null
            ,
            
        billing_city: data.billing_city
        ||
        null
            ,
            
        billing_state_region: data.billing_state_region
        ||
        null
            ,
            
        billing_postal_code: data.billing_postal_code
        ||
        null
            ,
            
        billing_country: data.billing_country
        ||
        null
            ,
            
        shipping_address_line1: data.shipping_address_line1
        ||
        null
            ,
            
        shipping_address_line2: data.shipping_address_line2
        ||
        null
            ,
            
        shipping_city: data.shipping_city
        ||
        null
            ,
            
        shipping_state_region: data.shipping_state_region
        ||
        null
            ,
            
        shipping_postal_code: data.shipping_postal_code
        ||
        null
            ,
            
        shipping_country: data.shipping_country
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await contacts.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        

        

        

        return contacts;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const contactsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                contact_type: item.contact_type
            ||
            null
            ,
            
                display_name: item.display_name
            ||
            null
            ,
            
                company_name: item.company_name
            ||
            null
            ,
            
                first_name: item.first_name
            ||
            null
            ,
            
                last_name: item.last_name
            ||
            null
            ,
            
                email: item.email
            ||
            null
            ,
            
                phone: item.phone
            ||
            null
            ,
            
                tin: item.tin
            ||
            null
            ,
            
                vrn: item.vrn
            ||
            null
            ,
            
                billing_address_line1: item.billing_address_line1
            ||
            null
            ,
            
                billing_address_line2: item.billing_address_line2
            ||
            null
            ,
            
                billing_city: item.billing_city
            ||
            null
            ,
            
                billing_state_region: item.billing_state_region
            ||
            null
            ,
            
                billing_postal_code: item.billing_postal_code
            ||
            null
            ,
            
                billing_country: item.billing_country
            ||
            null
            ,
            
                shipping_address_line1: item.shipping_address_line1
            ||
            null
            ,
            
                shipping_address_line2: item.shipping_address_line2
            ||
            null
            ,
            
                shipping_city: item.shipping_city
            ||
            null
            ,
            
                shipping_state_region: item.shipping_state_region
            ||
            null
            ,
            
                shipping_postal_code: item.shipping_postal_code
            ||
            null
            ,
            
                shipping_country: item.shipping_country
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const contacts = await db.contacts.bulkCreate(contactsData, { transaction });

        // For each item created, replace relation files
        

        return contacts;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const contacts = await db.contacts.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.contact_type !== undefined) updatePayload.contact_type = data.contact_type;
        
        
        if (data.display_name !== undefined) updatePayload.display_name = data.display_name;
        
        
        if (data.company_name !== undefined) updatePayload.company_name = data.company_name;
        
        
        if (data.first_name !== undefined) updatePayload.first_name = data.first_name;
        
        
        if (data.last_name !== undefined) updatePayload.last_name = data.last_name;
        
        
        if (data.email !== undefined) updatePayload.email = data.email;
        
        
        if (data.phone !== undefined) updatePayload.phone = data.phone;
        
        
        if (data.tin !== undefined) updatePayload.tin = data.tin;
        
        
        if (data.vrn !== undefined) updatePayload.vrn = data.vrn;
        
        
        if (data.billing_address_line1 !== undefined) updatePayload.billing_address_line1 = data.billing_address_line1;
        
        
        if (data.billing_address_line2 !== undefined) updatePayload.billing_address_line2 = data.billing_address_line2;
        
        
        if (data.billing_city !== undefined) updatePayload.billing_city = data.billing_city;
        
        
        if (data.billing_state_region !== undefined) updatePayload.billing_state_region = data.billing_state_region;
        
        
        if (data.billing_postal_code !== undefined) updatePayload.billing_postal_code = data.billing_postal_code;
        
        
        if (data.billing_country !== undefined) updatePayload.billing_country = data.billing_country;
        
        
        if (data.shipping_address_line1 !== undefined) updatePayload.shipping_address_line1 = data.shipping_address_line1;
        
        
        if (data.shipping_address_line2 !== undefined) updatePayload.shipping_address_line2 = data.shipping_address_line2;
        
        
        if (data.shipping_city !== undefined) updatePayload.shipping_city = data.shipping_city;
        
        
        if (data.shipping_state_region !== undefined) updatePayload.shipping_state_region = data.shipping_state_region;
        
        
        if (data.shipping_postal_code !== undefined) updatePayload.shipping_postal_code = data.shipping_postal_code;
        
        
        if (data.shipping_country !== undefined) updatePayload.shipping_country = data.shipping_country;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await contacts.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await contacts.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        

        
        

        

        return contacts;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const contacts = await db.contacts.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of contacts) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of contacts) {
                await record.destroy({transaction});
            }
        });


        return contacts;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const contacts = await db.contacts.findByPk(id, options);

        await contacts.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await contacts.destroy({
            transaction
        });

        return contacts;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const contacts = await db.contacts.findOne(
            { where },
            { transaction },
        );

        if (!contacts) {
            return contacts;
        }

        const output = contacts.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        output.quotes_customer = await contacts.getQuotes_customer({
            transaction
        });
        
        
        
        output.invoices_customer = await contacts.getInvoices_customer({
            transaction
        });
        
        
        
        output.payments_customer = await contacts.getPayments_customer({
            transaction
        });
        
        
        
        output.expenses_vendor = await contacts.getExpenses_vendor({
            transaction
        });
        
        
        
        output.projects_customer = await contacts.getProjects_customer({
            transaction
        });
        
        
        
        
        
        
        
        
        output.organization = await contacts.getOrganization({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.display_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'display_name',
                        filter.display_name,
                    ),
                };
            }
            
            if (filter.company_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'company_name',
                        filter.company_name,
                    ),
                };
            }
            
            if (filter.first_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'first_name',
                        filter.first_name,
                    ),
                };
            }
            
            if (filter.last_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'last_name',
                        filter.last_name,
                    ),
                };
            }
            
            if (filter.email) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'email',
                        filter.email,
                    ),
                };
            }
            
            if (filter.phone) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'phone',
                        filter.phone,
                    ),
                };
            }
            
            if (filter.tin) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'tin',
                        filter.tin,
                    ),
                };
            }
            
            if (filter.vrn) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'vrn',
                        filter.vrn,
                    ),
                };
            }
            
            if (filter.billing_address_line1) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'billing_address_line1',
                        filter.billing_address_line1,
                    ),
                };
            }
            
            if (filter.billing_address_line2) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'billing_address_line2',
                        filter.billing_address_line2,
                    ),
                };
            }
            
            if (filter.billing_city) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'billing_city',
                        filter.billing_city,
                    ),
                };
            }
            
            if (filter.billing_state_region) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'billing_state_region',
                        filter.billing_state_region,
                    ),
                };
            }
            
            if (filter.billing_postal_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'billing_postal_code',
                        filter.billing_postal_code,
                    ),
                };
            }
            
            if (filter.billing_country) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'billing_country',
                        filter.billing_country,
                    ),
                };
            }
            
            if (filter.shipping_address_line1) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'shipping_address_line1',
                        filter.shipping_address_line1,
                    ),
                };
            }
            
            if (filter.shipping_address_line2) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'shipping_address_line2',
                        filter.shipping_address_line2,
                    ),
                };
            }
            
            if (filter.shipping_city) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'shipping_city',
                        filter.shipping_city,
                    ),
                };
            }
            
            if (filter.shipping_state_region) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'shipping_state_region',
                        filter.shipping_state_region,
                    ),
                };
            }
            
            if (filter.shipping_postal_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'shipping_postal_code',
                        filter.shipping_postal_code,
                    ),
                };
            }
            
            if (filter.shipping_country) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'shipping_country',
                        filter.shipping_country,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.contact_type) {
                where = {
                    ...where,
                contact_type: filter.contact_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.contacts.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'contacts',
                        'display_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.contacts.findAll({
            attributes: [ 'id', 'display_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['display_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.display_name,
        }));
    }

    
};

